
#include "FpDriver.h"
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

int SaveFileData(const char* szFileName, unsigned char *buf,int length)
{
  FILE *fp;
  fp = fopen(szFileName,"wb");
  if(!fp)
    return -2;
  fwrite(buf,1,length,fp);
  fclose(fp);
  return 0;
}

int GetFileSize(const char* pcFileName)
{
  long size = 0;
  FILE *fp;
  fp = fopen(pcFileName,"rb");
  if(!fp)
    return 0;
  fseek(fp,0,SEEK_END);
  size = ftell(fp);
  fclose(fp);
  return size;
}

int GetFileData(const char* szFileName,unsigned char *buf,int length)
{
  FILE *fp;
  fp = fopen(szFileName,"rb");
  if(!fp)
    return -1;
  fread(buf,1,length,fp);
  fclose(fp);
  return 0;
}

int main(int argc,char *argv[])
{
	int lRV=-1;
	int flag = 1;
	char szAct[100];
	char lpBuf[100]={0};
	FILE *fp;
	char feat[513];
	char temp[513];
  	unsigned char imgBuf[30400];
  	unsigned char bmpBuf[30400+1078];
	int oMatchResult=0;
	int nImgLen;
	short oNum=0;
	while(flag)
	{
		printf("\n**************************************");
		printf("\n*    Miaxis function test            	*");
		printf("\n*                                    	*");
		printf("\n*      1. Get device version		*");
		printf("\n*      2. Detect Finger		*"); 
		printf("\n*      3. Get serial number		*"); 
  		printf("\n*      4. Enroll Finger		*"); 
		printf("\n*      5. Match Finger		*"); 
		printf("\n*      0. quit			*"); 
		printf("\n*                                    	*");
		printf("\n**************************************");  
		printf("\n      select(0-8):");
		gets(szAct);
		int mode= atoi(szAct);
		memset(lpBuf,0x00,100);
		switch(mode)
		{	
		case 1:	
			lRV=FPIGetDevVersion(1, lpBuf);
			if(lRV!=0)
			{
				 printf("Get version failed ret=%d ",lRV);
				 break;
			}
			printf(lpBuf);
			break;
		case 2:	
			lRV=FPIDetectFinger(1);
			if(lRV==0)
			{
				 printf("has finger ");
			}
      			else if(lRV==1)
      			{
				printf("no finger");
			}
      			else
      			{
				printf("detect finger failed ret=%d",lRV);
			}
			break;
		case 3:	
			lRV=FPIGetDevSN(1, lpBuf);
			if(lRV!=0)
			{
				 printf("Get serial number failed ret=%d ",lRV);
			}
      			else
      			{
			  	printf(lpBuf);
      			}
			break;
		case 4:
			printf("please press finger\r\n");
      			memset(temp, 0, sizeof(temp));
			lRV = FPIGetTemplate(1, 10000, temp);
			if(lRV!=0)
			{
				 printf("Get finger feature failed");
				 break;
			}
      			printf("finger:%s\n", temp);
			lRV=SaveFileData("mb.txt", temp, strlen(temp));
			if(lRV!=0)
			{
				printf("save data failed ");
				return 0;
			}
			printf("Get finger feature successed!");
			break;
		case 5:
      			lRV=GetFileSize("mb.txt");
			if(lRV<=0)
      			{
				printf("please enroll your finger first");
				break;
			}
			GetFileData("mb.txt", temp, lRV);
      
			printf("please press finger\r\n");
      			memset(feat, 0, sizeof(feat));
			lRV=FPIGetFeature(1, 10000, feat, imgBuf, &nImgLen);
			if(lRV!=0)
			{
				 printf("Get finger feature failed");
				 break;
			}
      			printf("feat:%s\n", feat);
			lRV = FPIGetImageBmp(imgBuf, bmpBuf);
			SaveFileData("finger.bmp", bmpBuf, lRV);
			lRV=FPIMatch(temp, feat,3);
			if(lRV==0)
      			{
				printf("match success");
			}
      			else 
      			{
				printf("match failed");
			}
			break;
		case 0:
			flag = 0;
			break;
		}
	}
	return 0;
}

